# $Id: devmon.spec 884 2008-05-10 20:46:37Z rpmbuild $
# repo: RE
# restrictions:

#
# Copyright (c) 2008 Mike Arnold <rpmpackaging@razorsedge.org>
#
# Please submit bugfixes or comments via http://rpm.razorsedge.org/bugs/
#

# Run rpmbuild with '--define="beta beta2"' to build a beta.

%define DEVMONUSER %([ $DEVMONUSER ] && echo $DEVMONUSER || echo "devmon" )
%define ver 0.3.0

Summary: Devmon monitors SNMP devices for Hobbit/BigBrother
Name: devmon
Version: %{ver}
%{!?beta:Release: %RErelease 3}
%{?beta:Release: %RErelease %{beta}.3}
Epoch: 0
License: GPL
Group: System Environment/Base
URL: http://devmon.sourceforge.net/
%{!?beta:Source0: http://prdownloads.sourceforge.net/devmon/%{name}-%{version}.tar.gz}
%{?beta:Source0: http://prdownloads.sourceforge.net/devmon/%{name}-%{ver}-%{beta}.tar.gz}
Source1: devmon.init.redhat
Source2: devmon.sysconfig.redhat
Source3: devmon.logrotate.redhat
Source4: devmon.init.aix
Source5: devmon.sysconfig.aix
Source6: devmon.logrotate.aix
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: rpm-macros-razorsedge
Requires: perl, perl-SNMP_Session
Requires(pre): fedora-usermgmt
Requires(postun): fedora-usermgmt
BuildArch: noarch

%description
Devmon is a device monitoring script which works in tandem with the
Hobbit/BigBrother monitoring suites. It queries remote hosts via SNMP, applies
user-defined logic and thresholds to the acquired data, and submits status and
alarms to a display server.

You need to install devmon-templates in order for devmon to do anything useful.

%prep
%{!?beta:%setup -q}
%{?beta:%setup -q -n %{name}-%{ver}-%{beta}}

%build
%{__cp} -p devmon devmon-orig
%{__sed} -e 's|^#!/usr/bin/perl|#!%{__perl}|' \
         -e '/^  use FindBin;$/d' \
         -e 's|use lib "$FindBin::Bin/modules";|use lib "%{_datadir}/%{name}/modules";|' devmon-orig > devmon
%{__cp} -p devmon.cfg devmon.cfg-orig
%{__sed} -e 's|^BBHOSTS=/home/hobbit/server/etc/bb-hosts$|BBHOSTS=%{_sysconfdir}/hobbit/bb-hosts|' \
         -e 's|^PIDFILE=/var/run/devmon/devmon.pid$|PIDFILE=%{_localstatedir}/run/%{name}/devmon.pid|' devmon.cfg-orig > devmon.cfg
%{__cp} -p modules/dm_config.pm modules/dm_config.pm-orig
%{__sed} -e '/^  use FindBin;$/d' \
         -e 's|=> '\''0.3.0-rc1'\'',$|=> '\''0.3.0'\'',|' \
         -e 's| => $FindBin::Bin,$| => "%{_datadir}/%{name}",|' \
         -e 's| => "$FindBin::Bin/devmon.cfg",$| => "%{_sysconfdir}/devmon.cfg",|' \
         -e 's| => "$FindBin::Bin/hosts.db",$| => "%{_localstatedir}/lib/%{name}/hosts.db",|' modules/dm_config.pm-orig > modules/dm_config.pm
%{__rm} modules/dm_config.pm-orig

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && %{__rm} -rf $RPM_BUILD_ROOT

%if "%_vendor" == "redhat"
%{__install} -m 755 -D %{SOURCE1} ${RPM_BUILD_ROOT}%{_initrddir}/%{name}
%{__install} -m 644 -D %{SOURCE2} ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{name}
%{__install} -m 644 -D %{SOURCE3} ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}
%endif
%if "%_os" == "aix"
%{__install} -m 755 -D %{SOURCE4} ${RPM_BUILD_ROOT}%{_initrddir}/%{name}
%{__install} -m 644 -D %{SOURCE5} ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{name}
%{__install} -m 644 -D %{SOURCE6} ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}
%endif
%{__chmod} -x extras/*
#%{__install} -m 644 -D extras/devmon-graph.cfg ${RPM_BUILD_ROOT}%{_sysconfdir}/hobbit/hobbitgraph.d/devmon-graph.cfg
%{__install} -m 640 -D devmon.cfg ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}.cfg
%{__install} -m 755 -d ${RPM_BUILD_ROOT}%{_datadir}/%{name}/
%{__cp} -pR modules ${RPM_BUILD_ROOT}%{_datadir}/%{name}/modules
#%{__cp} -pR templates ${RPM_BUILD_ROOT}%{_datadir}/%{name}/templates
%{__install} -m 755 -d ${RPM_BUILD_ROOT}%{_datadir}/%{name}/templates/
%{__cp} -p templates/README ${RPM_BUILD_ROOT}%{_datadir}/%{name}/templates
%{__install} -m 755 -D %{name} ${RPM_BUILD_ROOT}%{_sbindir}/%{name}
%{__install} -m 640 -D  /dev/null ${RPM_BUILD_ROOT}%{_localstatedir}/lib/%{name}/hosts.db
%{__install} -m 750 -d ${RPM_BUILD_ROOT}%{_localstatedir}/run/%{name}/

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && %{__rm} -rf $RPM_BUILD_ROOT

%pre
%if "%_os" == "linux"
getent passwd %DEVMONUSER >/dev/null 2>&1
%endif
%if "%_os" == "aix"
lsuser %DEVMONUSER >/dev/null 2>&1
%endif
if [ $? -ne 0 ]
then
%if "%_vendor" == "redhat"
  fedora-groupadd 76 -r %DEVMONUSER &>/dev/null || :
  fedora-useradd  76 -r -g %DEVMONUSER -c "Devmon Daemon" -d %{_localstatedir}/lib/%{name} -M %DEVMONUSER &>/dev/null || :
%endif
%if "%_os" == "aix"
  mkgroup id=105 %DEVMONUSER || true
  mkuser id=105 pgrp=%DEVMONUSER gecos="Devmon Daemon" home=%{_localstatedir}/lib/%{name} admin=false login=false rlogin=false %DEVMONUSER
  %{__rm} -rf %{_localstatedir}/hobbit
%endif
fi

%post
%if "%_vendor" == "redhat"
chkconfig --add devmon
%endif
%if "%_os" == "aix"
%{_sbindir}/chkconfig --add devmon
%endif

%preun
%if "%_vendor" == "redhat"
# Only if we are not upgrading...
if [ "$1" = 0 ]; then
  service devmon stop > /dev/null 2>&1 || :
  chkconfig --del devmon
fi
%endif
%if "%_os" == "aix"
# Only if we are not upgrading...
if [ "$1" = 0 ]; then
  %{_initrddir}/devmon stop > /dev/null 2>&1 || :
  %{_sbindir}/chkconfig --del devmon
fi
%endif

%postun
%if "%_vendor" == "redhat"
# Only if we are upgrading...
if [ "$1" -ge "1" ]; then
  service devmon condrestart > /dev/null 2>&1
else
  :
  #fedora-userdel %DEVMONUSER 2>/dev/null || :
  #fedora-groupdel %DEVMONUSER 2>/dev/null || :
fi
%endif
%if "%_os" == "aix"
# Only if we are upgrading...
if [ "$1" -ge "1" ]; then
  %{_initrddir}/devmon condrestart > /dev/null 2>&1
fi
%endif

%files
%defattr(-,root,root)
%doc README CHANGELOG COPYING docs/ extras/
%if "%_vendor" == "redhat"
%{_initrddir}/*
%config(noreplace) %{_sysconfdir}/sysconfig/*
%{_sysconfdir}/logrotate.d/*
%endif
%if "%_os" == "aix"
%{_initrddir}/*
%config(noreplace) %{_sysconfdir}/sysconfig/*
%{_sysconfdir}/logrotate.d/*
%endif
%config(noreplace) %attr(-, root, %DEVMONUSER) %{_sysconfdir}/%{name}.cfg
%{_datadir}/%{name}/
%{_sbindir}/*
%dir %attr(-, %DEVMONUSER, %DEVMONUSER) %{_localstatedir}/lib/%{name}/
%config(noreplace) %attr(-, %DEVMONUSER, %DEVMONUSER) %{_localstatedir}/lib/%{name}/hosts.db
%attr(-, %DEVMONUSER, %DEVMONUSER) %{_localstatedir}/run/%{name}/

%changelog
* Wed May 06 2008 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 0.3.0-3
- Moved files from %{_libdir} to %{_datadir}.
- Require fedora-usermgmt on Red Hat distros.
- Fixed Red Hat init script to kill devmon[master].
- Fixed version string in dm_config.pm to be 0.3.0 and not 0.3.0-rc1.

* Sat Apr 19 2008 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 0.3.0-2
- Removed templates from the main tarball.  They belong in devmon-templates.

* Fri Jul 20 2007 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 0.3.0-1
- Updated to version 0.3.0.
- Templates now come in a separate package: devmon-templates.
- Switched to creating noarch packages.

* Tue Apr 10 2007 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 0.2.2-3
- Fixed init script error codes to be LSB compliant.

* Sun Aug 13 2006 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 0.2.2-2
- Fixed logrotate bug.
- Fixed AIX packaging bug.

* Sun Aug 06 2006 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 0.2.2-1
- First build.

